#ifndef INC_GTBUTTON_H
#define INC_GTBUTTON_H

#include "gtgroup.h"
#include "gtcblist.h"

/************************************************************************\
*
* GtButton class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

class GtMenu;

/* Flags for button (internal use) */
#define GTBF_REPEAT		0x01
#define GTBF_ARMED		0x02
#define GTBF_PRESS		0x04

/* Callback data */
typedef struct GtButtonCD
{
	ulong button;
	ulong state;
	word multi;
} GtButtonCD;

class GtButton : public GtGroup
{
public:
		/* Standard */
	GtButton(void);
	void Destroy(void);
	sbool Init(char *n,GtManager *p,GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtButton"); }
	sbool IsSubClassOf(char *cn);
		/* Values */
	void SetEMask(ulong em);
		/* Callbacks */
	void AddCB(ulong tag,GtCallB cb,GtUDPtr ud);
	void RemCB(ulong tag,GtCallB cb);
		/* Notify */
	void Notify(ulong tag);
protected:
		/* Internal methods */
	sbool Draw(XEvent *xe);
	sbool Mouse(XEvent *xe);
	virtual void Arm(ulong button,ulong state);
	virtual void Activate(ulong button,ulong state);
	virtual void DisArm(ulong button,ulong state);
private:
	static int TimeOut(GtBase *obj,GtCDPtr cd,GtUDPtr ud);
	static int ShortCut(GtBase *obj,GtCDPtr cd,GtUDPtr ud);
protected:
		/* Instance variables */
	GtCBList arm,act,darm;
	GtMenu *mshell;
	char *shortcut;
	int scid;
	long delay,idelay;
	ulong bmask;
	Time last;
	word mclk;
	ubyte bflags,bpress;
};

extern GtButton *GtMkButton(char *n,GtManager *p,GtTag *tgs);
extern GtButton *GtMkButton(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTBUTTON_H */
