#ifndef INC_GTPIXMAP_H
#define INC_GTPIXMAP_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "gtdrawable.h"
#include "gtdisplay.h"

/************************************************************************\
*
* GtPixmap class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

class GtPixmap : public GtDrawable
{
public:
		/* Standard */
	GtPixmap(void);
	void Destroy(void);
	void DeInit(void);
	sbool Init(GtDisplay *d,GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtPixmap"); }
	sbool IsSubClassOf(char *cn);
	inline sbool IsBitmap(void) { return(depth==1 ? TRUE : FALSE); }
		/* Values */
	inline Pixmap XPix(void) { return(pix); }
	friend GtPixmap *GtMkSharedPixmap(GtDisplay *d,GtTag *tgs);
protected:
	GtPixmap *next;
	GtDrawable *dra;
	Pixmap pix,mask;
	char *data,*fname;
	unsigned int xsize,ysize;
	int depth,hotx,hoty;
	int cnt;
	sbool nofreex;
};

extern GtPixmap *GtMkPixmap(GtDisplay *d,GtTag *tgs);
extern GtPixmap *GtMkPixmap(GtDisplay *d,ulong tag,...);
extern GtPixmap *GtMkSharedPixmap(GtDisplay *d,GtTag *tgs);
extern GtPixmap *GtMkSharedPixmap(GtDisplay *d,ulong tag,...);

extern sbool GtXpmSupport(void);

#endif /* INC_GTPIXMAP_H */
